<template>
  <div class="modal-container">
    <div class="modal-header">
      <div class="md-title">Modify Login Password</div>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="form">
        <md-field md-has-password>
          <label>{{ $t('messages.auth.changePassword.currentPassword') }}</label>
          <md-input
            @keyup.enter="changePassword"
            v-validate="'required|min:6'"
            @focus="resetError"
            data-vv-validate-on="none"
            v-model="currentPassword"
            type="password"
            data-vv-as="current password"
            name="current_password"
            class="input">
          </md-input>
        </md-field>
        <span class="invalid-feedback" v-if="errors.has('current_password')">{{ errors.first('current_password') }}</span>
        <md-field md-has-password>
          <label>New password</label>
          <md-input
            data-vv-as="new password"
            @keyup.enter="changePassword"
            v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
            @focus="resetError"
            v-model="newPassword"
            data-vv-validate-on="none"
            name="password"
            type="password">
          </md-input>
        </md-field>
        <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }}</span>
        <md-field md-has-password>
          <label>Password confirmation</label>
          <md-input
            data-vv-as="password confirmation"
            @keyup.enter="changePassword"
            ref="password_confirmation"
            v-validate="'required'"
            @focus="resetError"
            data-vv-validate-on="none"
            v-model="passwordConfirmation"
            name="password_confirmation"
            type="password"
            class="input">
          </md-input>
        </md-field>
        <span class="invalid-feedback" v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
        <span class="invalid-feedback" v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
      </div>
      <div class="actions md-alignment-center-space-between text-center">
        <md-button class="md-primary" @click="changePassword">Change Password</md-button>
      </div>
    </div>
  </div>
</template>
<script>
import rf from '../../../../common/requests/RequestFactory';
import OtpConfirmModal from '../../../../common/components/Otp/OtpConfirmModal.vue';

export default {
  data() {
    return {
      currentPassword: null,
      newPassword: null,
      passwordConfirmation: null,
    }
  },
  computed: {
    isShowPasswordError () {
      return this.errors.has('password') && !this.errors.firstByRule('password', 'confirmed');
    },
    isShowPasswordConfirmedError () {
      return !!this.errors.firstByRule('password', 'confirmed') && !this.errors.firstByRule('password_confirmation', 'required');
    }
  },
  props: {
    modalData: {
      type: Object,
    }
  },
  methods: {
    closeModal() {
      this.$broadcast('close-modal');
    },
    resetError() {
      this.errors.clear();
    },
    changePassword() {
      this.$validator.validateAll()
      .then(() => {
        if (this.errors.any()) {
          return;
        }
        const params = Object.assign({}, {
          current_password: this.currentPassword,
          password: this.newPassword,
          password_confirmation: this.passwordConfirmation,
        });
        rf.getRequest('UserRequest')
          .changePassword(params)
          .then(() => {
            this.closeModal();
            this.changePasswordSuccessful();
          })
          .catch((error) => {
            const errors = error.errors;
            this.errors.clear();
            Object.keys(errors).forEach((key) => {
              this.errors.add({
                field: key,
                msg: errors[key][0]
              });
            });
            if (this.errors.has('code')) {
              this.$broadcast('open-modal', OtpConfirmModal, {
                callback: this.requestChangePassword,
                key: `requestChangePassword`,
                params: params,
              });
            }
          });
      });
    },
    requestChangePassword (params) {
      return rf.getRequest('UserRequest').changePassword(params);
    },
    changePasswordSuccessful () {
      this.$toasted.show(this.$t('messages.auth.changePassword.changePasswordSuccessful'), {
        theme: 'bubble',
        position: 'top-right',
        duration : 1000
      });

      setTimeout(() => {
        window.location.href = '/admin/login';
      }, 1000);
    },
  },
};
</script>
<style scoped lang="scss">
  @import '../../../../../sass/_variables.scss';
  * {
    font-family: $font-family-home;
  }
  .invalid-feedback {
    font-size: 13px;
    color: red;
    display: block;
    margin-top: -14px;
    margin-bottom: 10px;
  }
  .modal-container {
    width: 450px;
    height: 450px;
    background-color: $bg_white;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    margin: auto;
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .md-title {
        text-align: center;
        padding-top: 30px;
      }
      .btn-close {
        width: 30px;
        height: 30px;
        background-color: $bg_white;
        border: 1px solid $white;
        border-radius: 50%;
        position: absolute;
        outline: none;
        top: 15px;
        right: 15px;
        span {
          cursor: pointer;
          color: $thin_gray;
          font-size: 17px;
        }
      }
    }
    .modal-body {
      margin: 0;
      padding: 40px;
    }
  }
</style>
